## cedarview-drm-drivers 20120717

=== Makefile ===
#
# Makefile for the drm device driver.  This driver provides support for the
# Direct Rendering Infrastructure (DRI) in XFree86 4.1.0 and higher.

include /boot/config-$(KVER)

export CONFIG_STAGING=y
export CONFIG_DRM_INTEL_CDV=m
export CONFIG_DRM_CDV_RELEASE=y
unexport CONFIG_DRM_PSB_CDV

ccflags-y := -I/var/lib/dkms/cedarview-drm/20120717/build/include

drm-y       :=	drm_auth.o drm_buffer.o drm_bufs.o drm_cache.o \
		drm_context.o drm_dma.o \
		drm_drv.o drm_fops.o drm_gem.o drm_ioctl.o drm_irq.o \
		drm_lock.o drm_memory.o drm_proc.o drm_stub.o drm_vm.o \
		drm_agpsupport.o drm_scatter.o ati_pcigart.o drm_pci.o \
		drm_platform.o drm_sysfs.o drm_hashtab.o drm_sman.o drm_mm.o \
		drm_crtc.o drm_modes.o drm_edid.o \
		drm_info.o drm_debugfs.o drm_encoder_slave.o \
		drm_trace_points.o drm_global.o drm_usb.o

drm-$(CONFIG_COMPAT) += drm_ioc32.o

drm_kms_helper-y := drm_fb_helper.o drm_crtc_helper.o drm_dp_i2c_helper.o

obj-$(CONFIG_DRM_KMS_HELPER) += drm_kms_helper.o

CFLAGS_drm_trace_points.o := -I$(src)

obj-$(CONFIG_DRM)	+= drm.o
obj-$(CONFIG_DRM_TTM)	+= ttm/
obj-$(CONFIG_STAGING)	+= staging/
#obj-$(CONFIG_DRM_TDFX)	+= tdfx/
#obj-$(CONFIG_DRM_R128)	+= r128/
#obj-$(CONFIG_DRM_RADEON)+= radeon/
#obj-$(CONFIG_DRM_MGA)	+= mga/
#obj-$(CONFIG_DRM_I810)	+= i810/
#obj-$(CONFIG_DRM_I915)  += i915/
#obj-$(CONFIG_DRM_SIS)   += sis/
#obj-$(CONFIG_DRM_SAVAGE)+= savage/
#obj-$(CONFIG_DRM_VMWGFX)+= vmwgfx/
#obj-$(CONFIG_DRM_VIA)	+=via/
#obj-$(CONFIG_DRM_NOUVEAU) +=nouveau/
#obj-$(CONFIG_DRM_EXYNOS) +=exynos/
obj-y			+= i2c/

all:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules

clean:
	make -C /lib/modules/$(KVER)/build M=`pwd` clean

=== staging/Makefile ===
# Makefile for staging directory

# fix for build system bug...
obj-$(CONFIG_STAGING)		+= staging.o

obj-y				+= serial/
obj-y				+= media/
obj-$(CONFIG_ET131X)		+= et131x/
obj-$(CONFIG_SLICOSS)		+= slicoss/
obj-$(CONFIG_USBIP_CORE)	+= usbip/
obj-$(CONFIG_W35UND)		+= winbond/
obj-$(CONFIG_PRISM2_USB)	+= wlan-ng/
obj-$(CONFIG_ECHO)		+= echo/
obj-$(CONFIG_COMEDI)		+= comedi/
obj-$(CONFIG_FB_OLPC_DCON)	+= olpc_dcon/
obj-$(CONFIG_ASUS_OLED)		+= asus_oled/
obj-$(CONFIG_PANEL)		+= panel/
obj-$(CONFIG_R8187SE)		+= rtl8187se/
obj-$(CONFIG_RTL8192U)		+= rtl8192u/
obj-$(CONFIG_RTL8192E)		+= rtl8192e/
obj-$(CONFIG_R8712U)		+= rtl8712/
obj-$(CONFIG_RTS_PSTOR)		+= rts_pstor/
obj-$(CONFIG_RTS5139)		+= rts5139/
obj-$(CONFIG_SPECTRA)		+= spectra/
obj-$(CONFIG_TRANZPORT)		+= frontier/
obj-$(CONFIG_POHMELFS)		+= pohmelfs/
obj-$(CONFIG_IDE_PHISON)	+= phison/
obj-$(CONFIG_LINE6_USB)		+= line6/
obj-$(CONFIG_USB_SERIAL_QUATECH2)	+= serqt_usb2/
obj-$(CONFIG_USB_SERIAL_QUATECH_USB2)	+= quatech_usb2/
obj-$(CONFIG_OCTEON_ETHERNET)	+= octeon/
obj-$(CONFIG_VT6655)		+= vt6655/
#obj-$(CONFIG_VT6656)		+= vt6656/
obj-$(CONFIG_VME_BUS)		+= vme/
obj-$(CONFIG_DX_SEP)            += sep/
obj-$(CONFIG_IIO)		+= iio/
obj-$(CONFIG_ZRAM)		+= zram/
obj-$(CONFIG_XVMALLOC)		+= zram/
obj-$(CONFIG_ZCACHE)		+= zcache/
obj-$(CONFIG_WLAGS49_H2)	+= wlags49_h2/
obj-$(CONFIG_WLAGS49_H25)	+= wlags49_h25/
obj-$(CONFIG_FB_SM7XX)		+= sm7xx/
obj-$(CONFIG_CRYSTALHD)		+= crystalhd/
obj-$(CONFIG_CXT1E1)		+= cxt1e1/
obj-$(CONFIG_FB_XGI)		+= xgifb/
obj-$(CONFIG_TIDSPBRIDGE)	+= tidspbridge/
obj-$(CONFIG_ACPI_QUICKSTART)	+= quickstart/
obj-$(CONFIG_SBE_2T3E3)		+= sbe-2t3e3/
obj-$(CONFIG_USB_ENESTORAGE)	+= keucr/
obj-$(CONFIG_BCM_WIMAX)		+= bcm/
obj-$(CONFIG_FT1000)		+= ft1000/
obj-$(CONFIG_SND_INTEL_SST)	+= intel_sst/
obj-$(CONFIG_SPEAKUP)		+= speakup/
obj-$(CONFIG_TOUCHSCREEN_CLEARPAD_TM1217)	+= cptm1217/
obj-$(CONFIG_TOUCHSCREEN_SYNAPTICS_I2C_RMI4)	+= ste_rmi4/
obj-$(CONFIG_DRM_PSB)		+= gma500/
obj-$(CONFIG_INTEL_MEI)		+= mei/
obj-$(CONFIG_MFD_NVEC)		+= nvec/

=== debian/changelog ===
cedarview-drm-drivers (20120717-0ubuntu1) precise-proposed; urgency=low

  * Initial release (LP: #1025720).

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 01 Aug 2012 16:28:29 +0200

=== debian/control ===
Source: cedarview-drm-drivers
Section: kernel
Priority: optional
Maintainer: Alberto Milone <alberto.milone@canonical.com>
Build-Depends: debhelper (>= 7.0.50~), dkms (>=1.95), quilt, dh-modaliases
Standards-Version: 3.9.1

Package: cedarview-drm
Architecture: i386
Depends: grub-gfxpayload-lists,
 linux-headers-generic (>= 2.6) | linux-headers-generic-pae (>= 2.6),
 ${misc:Depends},
XB-Modaliases: ${modaliases}
Description: Cedar Trail drm driver in DKMS format.
 This package contains the drm driver for Cedar Trail in DKMS format.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEBVERS  := $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
                | cut -d- -f1)
#VERSION  := $(shell echo '$(DEBVERS)' | sed -e 's/[+-].*//' -e 's/~//g')

PKG_driver  := cedarview-drm
PKG_version          := $(shell dpkg-parsechangelog | awk -F' ' '/^Version:/ {print $$2}' | awk -F- '{print $$1}')
PKG_source           := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
PKG_module      := cedarview_gfx

SRCPATH  := /var/lib/dkms/$(PKG_driver)/$(PKG_version)/build

NAME = $(shell dh_listpackages)
TMP     = $(CURDIR)/debian/tmp

PKG_kernel_source_dir := /usr/src
SRC = $(TMP)$(PKG_kernel_source_dir)
BLACKLISTS = $(TMP)/etc/modprobe.d
PKG_blacklist_file := /etc/modprobe.d/$(PKG_driver).conf

GRUB_BLACKLISTS = $(TMP)/usr/share/grub-gfxpayload-lists/blacklist

PKG_lightdm_config_dir := /etc/lightdm
PKG_lightdm_config_file := $(PKG_lightdm_config_dir)/lightdm.conf
LIGHTDM_CONF_DIR := $(TMP)$(PKG_lightdm_config_dir)
PKG_lightdm_custom_config_dir := /usr/share/$(PKG_driver)
PKG_lightdm_custom_config_file := $(PKG_lightdm_custom_config_dir)/lightdm.conf
LIGHTDM_CUSTOM_CONF_DIR := $(TMP)$(PKG_lightdm_custom_config_dir)
PKG_dkms_force_dir := /usr/share/dkms/modules_to_force_install
PKG_dkms_force_file := $(PKG_dkms_force_dir)/$(PKG_driver)
DKMS_FORCE_DIR := $(TMP)$(PKG_dkms_force_dir)

readme_list := "$(CURDIR)/temp_ids"

#These "define" bits are needed for the blacklist file
define newline


endef

define blacklist_file
# This file was installed by $(PKG_driver)
# Do not edit this file manually

blacklist psb_gfx
alias psb_gfx off
endef


%:
	dh $@ --with dkms

.PHONY: regen-from-templates
regen-from-templates:
	for i in $(CURDIR)/debian/dkms \
		 $(CURDIR)/debian/control \
		 $(CURDIR)/debian/install \
		 $(CURDIR)/debian/preinst \
		 $(CURDIR)/debian/postinst \
		 $(CURDIR)/debian/postrm \
		 $(CURDIR)/Makefile; do \
		sed -e 's|#VERSION#|$(PKG_version)|g' \
			-e 's|#SRCPATH#|$(SRCPATH)|g' \
			-e 's|#DRIVERNAME#|$(PKG_driver)|g' \
			-e "s|#DRIVERSRCNAME#|$(PKG_source)|g" \
			-e "s|#BLACKLIST_FILE#|$(PKG_blacklist_file)|g" \
			-e "s|#LIGHTDM_CONF_FILE#|$(PKG_lightdm_config_file)|g" \
			-e "s|#LIGHTDM_CONF_DIR#|$(PKG_lightdm_config_dir)|g" \
			-e "s|#LIGHTDM_CUSTOM_CONF_FILE#|$(PKG_lightdm_custom_config_file)|g" \
			-e "s|#LIGHTDM_CUSTOM_CONF_DIR#|$(PKG_lightdm_custom_config_dir)|g" \
			-e "s|#DKMS_FORCE_DIR#|$(PKG_dkms_force_dir)|g" \
		$$i.in > $$i; \
	done

override_dh_auto_build:
override_dh_auto_clean: regen-from-templates

override_dh_auto_install: regen-from-templates
	install -d "$(SRC)"
	mkdir "$(SRC)/$(NAME)-$(PKG_version)"
	cp -a `ls | grep -v debian` "$(SRC)/$(NAME)-$(PKG_version)"
	chmod 644 -R "$(SRC)/$(NAME)-$(PKG_version)"
	find "$(SRC)/$(NAME)-$(PKG_version)" -type d -exec chmod 755 {} \;

	install -d "$(BLACKLISTS)"
	# Permanently blacklist psb_gfx so that cdv can be loaded
	printf '$(subst $(newline),\n,${blacklist_file})' > \
		$(BLACKLISTS)/$(PKG_driver).conf

	# Install file to force DKMS to override modules
	install -d "$(DKMS_FORCE_DIR)"
	printf '$(PKG_driver)' > $(DKMS_FORCE_DIR)/$(PKG_driver)

	# Generate modaliases
	sed -n -e 's/.*{0x8086, 0x\([^, ]*\).*/\1/p' \
		'$(CURDIR)/debian/patches/07_kernel-3.2-cdv.diff' \
		> $(readme_list)

	install -d $(GRUB_BLACKLISTS)
	for id in $$(cat $(readme_list)); do \
		echo v8086d$$id.*; done \
	> $(GRUB_BLACKLISTS)/20_$(PKG_module)

	for id in $$(cat $(readme_list)); do \
		printf 'alias pci:v%08Xd%08Xsv*sd*bc03sc*i* %s %s\n' \
		0x8086 0x"$$id" "$(PKG_module)" "$(PKG_driver)"; done \
	> debian/$(PKG_driver).modaliases
	dh_modaliases
	rm debian/$(PKG_driver).modaliases

	rm -f $(readme_list)
